<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;

class LojaParametrizacaoFrenteDeCaixaController extends CrudWithParameterBag {

    protected $dataSourceName = 'ger12300_cadloja_parametrizacao_frenteDeCaixa';
    protected $parameterBagColumns = array('CDFILIAL', 'CDLOJA', 'NRORG');
    
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, $connection) {
        $this->utilService = $utilService;
        parent::__construct($dataSourceManager, $parameterBag);
        $this->connection = $connection;
        
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();
        
        $queryLoja = "UPDATE LOJA 
                    SET
                      CDPRODCOUVER = :CDPRODCOUVER, 
                      CDVENDPADRAO = :CDVENDPADRAO, 
                      CDPRODCONSUM = :CDPRODCONSUM, 
                      CDPRODCONSUF = :CDPRODCONSUF,
                      CDPRODTAXASERV = :CDPRODTAXASERV, 
                      CDPRODTAXAENTR = :CDPRODTAXAENTR, 
                      IDTRATTAXASERV = :IDTRATTAXASERV,
                      IDCOUVERART = :IDCOUVERART,
                      IDCONSUMAMIN = :IDCONSUMAMIN,
                      IDUTIVENDPAD = :IDUTIVENDPAD,
                      IDCONTROPROD = :IDCONTROPROD,
                      IDIMPCNPJCLIE = :IDIMPCNPJCLIE,
                      IDTRATTAXAENTR = :IDTRATTAXAENTR,
                      IDIMPCUPTROCA = :IDIMPCUPTROCA,
                      IDCOMISVENDA = :IDCOMISVENDA,
                      VRCOMISVENDA = :VRCOMISVENDA,
                      VRCOMISVENDA2 = :VRCOMISVENDA2,
                      VRCOMISVENDA3 = :VRCOMISVENDA3,
                      NRDIASCUPTROCA = :NRDIASCUPTROCA,
                      IDMOSTRADESPARC = :IDMOSTRADESPARC,
                      CDPRODTXEXCEDE = :CDPRODTXEXCEDE,
                      IDSELECONSABERMESA = :IDSELECONSABERMESA,
                      IDUTILLOGGI = :IDUTILLOGGI,
                      CDURLWSLOGGI = :CDURLWSLOGGI,
                      DSEMAILLOGGI = :DSEMAILLOGGI,
                      CDAPIKEYLOGGI = :CDAPIKEYLOGGI,
                      IDSINCQUANTDIA = :IDSINCQUANTDIA,
                      IDALTORIGPEDDLV = :IDALTORIGPEDDLV,
                      DSENDEZEBRA = :DSENDEZEBRA,
                      IDSOLOPERTXSRVAP = :IDSOLOPERTXSRVAP,
                      IDORDCONTENTR = :IDORDCONTENTR,
                      IDIMPPUXANTPED = :IDIMPPUXANTPED,
                      IDCRMBONUS = :IDCRMBONUS,
                      CDURLCRMBONUS = :CDURLCRMBONUS,
                      CDAUTHCRMBONUS = :CDAUTHCRMBONUS,
                      CDCODECRMBONUS = :CDCODECRMBONUS,
                      DSTEXTOTXSERV =  :DSTEXTOTXSERV
                    WHERE (NRORG = :NRORG) 
                        AND (CDLOJA = :CDLOJA) 
                        AND (CDFILIAL = :CDFILIAL)";
                        
        $stmt = $this->connection->prepare($queryLoja); 
		$stmt->execute(array(
		    
		    "CDVENDPADRAO"      => $data[0]['CDVENDPADRAO'],
		    "CDPRODCOUVER"      => $data[0]['CDPRODCOUVER'],
            "CDVENDPADRAO"      => $data[0]['CDVENDPADRAO'],
            "CDPRODCONSUM"      => $data[0]['CDPRODCONSUM'],
            "CDPRODCONSUF"      => $data[0]['CDPRODCONSUF'],
            "CDPRODTAXASERV"    => $data[0]['CDPRODTAXASERV'],
            "CDPRODTAXAENTR"    => $data[0]['CDPRODTAXAENTR'],
            "IDTRATTAXASERV"    => $data[0]['IDTRATTAXASERV'],
            "IDCOUVERART"       => $data[0]['IDCOUVERART'],
            "IDCONSUMAMIN"      => $data[0]['IDCONSUMAMIN'],
            "IDUTIVENDPAD"      => $data[0]['IDUTIVENDPAD'],
            "IDCONTROPROD"      => $data[0]['IDCONTROPROD'],
            "IDIMPCNPJCLIE"     => $data[0]['IDIMPCNPJCLIE'],
            "IDTRATTAXAENTR"    => $data[0]['IDTRATTAXAENTR'],
            "IDIMPCUPTROCA"     => $data[0]['IDIMPCUPTROCA'],
            "IDCOMISVENDA"      => $data[0]['IDCOMISVENDA'],
            "VRCOMISVENDA"      => $data[0]['VRCOMISVENDA'],
            "VRCOMISVENDA2"     => $data[0]['VRCOMISVENDA2'],
            "VRCOMISVENDA3"     => $data[0]['VRCOMISVENDA3'],
            "NRDIASCUPTROCA"    => $data[0]['NRDIASCUPTROCA'],
            "IDMOSTRADESPARC"   => $data[0]['IDMOSTRADESPARC'],
            "NRORG"             => $data[0]['NRORG'],
		    "CDLOJA"            => $data[0]['CDLOJA'],
		    "CDFILIAL"          => $data[0]['CDFILIAL'],
		    "CDPRODTXEXCEDE"    => $data[0]['CDPRODTXEXCEDE'],
		    "IDSELECONSABERMESA"=> $data[0]['IDSELECONSABERMESA'],
            "IDUTILLOGGI"       => $data[0]['IDUTILLOGGI'],
            "CDURLWSLOGGI"      => $data[0]['CDURLWSLOGGI'],
            "DSEMAILLOGGI"      => $data[0]['DSEMAILLOGGI'],
            "CDAPIKEYLOGGI"     => $data[0]['CDAPIKEYLOGGI'],
            "IDSINCQUANTDIA"    => $data[0]['IDSINCQUANTDIA'],
            "IDALTORIGPEDDLV"   => $data[0]['IDALTORIGPEDDLV'],
            "DSENDEZEBRA"       => $data[0]['DSENDEZEBRA'],
            "IDSOLOPERTXSRVAP"  => $data[0]['IDSOLOPERTXSRVAP'],
            "IDORDCONTENTR"     => $data[0]['IDORDCONTENTR'],
            "IDIMPPUXANTPED"    => $data[0]['IDIMPPUXANTPED'],
            "IDCRMBONUS"        => $data[0]['IDCRMBONUS'],
            "CDURLCRMBONUS"     => $data[0]['CDURLCRMBONUS'],
            "CDAUTHCRMBONUS"    => $data[0]['CDAUTHCRMBONUS'],
            "CDCODECRMBONUS"    => $data[0]['CDCODECRMBONUS'],
            "DSTEXTOTXSERV"     => $data[0]['DSTEXTOTXSERV']
		));
    }
    
    public function save2(DTO\Request\DataSet $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();
        
        $queryLoja = "UPDATE
                        LOJA 
                    SET
                        IDPOSOBSPED     = :IDPOSOBSPED,
                        IDSOLOBSPED     = :IDSOLOBSPED, 
                        CDGRPOCORPED    = :CDGRPOCORPED, 
                        IDSOLOBSCAN     = :IDSOLOBSCAN, 
                        CDGRPOCORCAN    = :CDGRPOCORCAN, 
                        IDSOLOBSCANCUP  = :IDSOLOBSCANCUP, 
                        CDGRPOCORCANCUP = :CDGRPOCORCANCUP,
                        IDOBRIGAOBSCAN  = :IDOBRIGAOBSCAN,
                        IDSOLOBSDESC    = :IDSOLOBSDESC, 
                        CDGRPOCORDESC   = :CDGRPOCORDESC,
                        CDGROBENVMENSP  = :CDGROBENVMENSP,
                        IDSOLOBSFINVEN  = :IDSOLOBSFINVEN
                    WHERE
                        (NRORG = :NRORG) 
                        AND 
                        (CDLOJA = :CDLOJA) 
                        AND 
                        (CDFILIAL = :CDFILIAL)";
                        
        $stmt = $this->connection->prepare($queryLoja); 
		$stmt->execute(array(
		    "IDPOSOBSPED"       => $data[0]['IDPOSOBSPED'],
		    "IDSOLOBSPED"       => $data[0]['IDSOLOBSPED'],
		    "CDGRPOCORPED"      => $data[0]['CDGRPOCORPED'],
            "IDSOLOBSCAN"       => $data[0]['IDSOLOBSCAN'],
            "CDGRPOCORCAN"      => $data[0]['CDGRPOCORCAN'],
            "IDSOLOBSCANCUP"    => $data[0]['IDSOLOBSCANCUP'],
            "IDSOLOBSDESC"      => $data[0]['IDSOLOBSDESC'],
		    'IDOBRIGAOBSCAN'    => $data[0]['IDOBRIGAOBSCAN'],
            "CDGRPOCORDESC"     => $data[0]['CDGRPOCORDESC'],
            "CDGROBENVMENSP"    => $data[0]['CDGROBENVMENSP'],
            "CDGRPOCORCANCUP"   => $data[0]['CDGRPOCORCANCUP'],
            "IDSOLOBSFINVEN"    => $data[0]['IDSOLOBSFINVEN'],
            "NRORG"             => $data[0]['NRORG'],
		    "CDLOJA"            => $data[0]['CDLOJA'],
		    "CDFILIAL"          => $data[0]['CDFILIAL']
		));
    }
    
    public function save3(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();

        if(!empty($rows)) {
            $data = $rows[0];
            $queryLoja = self::UPDATE_FRENTE_DE_CAIXA_3;
                            
            $stmt = $this->connection->prepare($queryLoja);
            
            if(!isset($data['IDUTLCORTEPED'])) {
                $data['IDUTLCORTEPED'] = "N";
            }
            
            if(!isset($data['IDUTLNMCONSMESA'])) {
                $data['IDUTLNMCONSMESA'] = "N";
            }
            
            $params = array(
    		    "IDUTLNMCONSMESA"       => $data['IDUTLNMCONSMESA'],
    		    "IDALTTXSERV"           => $data['IDALTTXSERV'],
    		    "IDOBRFECHDLV"          => $data['IDOBRFECHDLV'],
    		    "IDEXIBTICCUP"          => $data['IDEXIBTICCUP'],
    		    "QTMAXPERVNDPROD"       => $data['QTMAXPERVNDPROD'],
    		    "NRMINSEMCONS"          => $data['NRMINSEMCONS'],
    		    "IDLUGARMESA"           => $data['IDLUGARMESA'],
    		    "IDEXIBEMENSOP"         => $data['IDEXIBEMENSOP'],
    		    "QTMAXPEDFOS"           => $data['QTMAXPEDFOS'],
    		    "IDTIPCOBRA"            => $data['IDTIPCOBRA'],
    		    "DSMENSOPERLOJA"        => $data['DSMENSOPERLOJA'],
    		    "IDDESBLOPRODAUT"       => $data['IDDESBLOPRODAUT'],
    		    "VRMAXDESCONTO"         => $data['VRMAXDESCONTO'],
    		    "IDUTLSENHAOPER"        => $data['IDUTLSENHAOPER'],
    		    "IDUTLCORTEPED"         => $data['IDUTLCORTEPED'] ,
    		    "NRORG"                 => $data['NRORG'],
    		    "CDLOJA"                => $data['CDLOJA'],
    		    "CDFILIAL"              => $data['CDFILIAL'],
    		    "IDSELECONSABERMESA"    => $data['IDSELECONSABERMESA'],
    		    "IDCONDPEDPAG"          => $data['IDCONDPEDPAG']
    		);
            
    		$stmt->execute($params);
        }
    }
    
    public function save4(DTO\Request\DataSet $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();
  
        $queryLoja = self::UPDATE_FRENTE_DE_CAIXA_4;
                        
        $stmt = $this->connection->prepare($queryLoja); 
		$stmt->execute(array(
            "NRORG"            => $data[0]['NRORG'],
		    "CDLOJA"           => $data[0]['CDLOJA'],
		    "CDFILIAL"         => $data[0]['CDFILIAL'],
            "IDUTILLOGGI"      => $data[0]['IDUTILLOGGI'],
            "CDURLWSLOGGI"     => $data[0]['CDURLWSLOGGI'],
            "DSEMAILLOGGI"     => $data[0]['DSEMAILLOGGI'],
            "CDAPIKEYLOGGI"    => $data[0]['CDAPIKEYLOGGI'],
            "IDSINCQUANTDIA"   => $data[0]['IDSINCQUANTDIA'],
            "IDALTORIGPEDDLV"  => $data[0]['IDALTORIGPEDDLV'],
            "DSENDEZEBRA"      => $data[0]['DSENDEZEBRA'],
            "IDSOLOPERTXSRVAP" => $data[0]['IDSOLOPERTXSRVAP'],
            "IDORDCONTENTR"    => $data[0]['IDORDCONTENTR'],
            "IDIMPPUXANTPED"   => $data[0]['IDIMPPUXANTPED'],
            "IDCRMBONUS"       => $data[0]['IDCRMBONUS'],
            "CDURLCRMBONUS"    => $data[0]['CDURLCRMBONUS'],
            "CDAUTHCRMBONUS"   => $data[0]['CDAUTHCRMBONUS'],
            "CDCODECRMBONUS"   => $data[0]['CDCODECRMBONUS']
		));
    }
    
    const UPDATE_FRENTE_DE_CAIXA_3 = "UPDATE LOJA 
                                         SET IDUTLNMCONSMESA = :IDUTLNMCONSMESA,
                                             IDEXIBTICCUP = :IDEXIBTICCUP,
                                             QTMAXPERVNDPROD = :QTMAXPERVNDPROD,
                                             NRMINSEMCONS = :NRMINSEMCONS,
                                             IDLUGARMESA = :IDLUGARMESA,
                                             IDEXIBEMENSOP = :IDEXIBEMENSOP,
                                             QTMAXPEDFOS = :QTMAXPEDFOS,
                                             IDTIPCOBRA = :IDTIPCOBRA,
                                             DSMENSOPERLOJA = :DSMENSOPERLOJA,
                                             IDDESBLOPRODAUT = :IDDESBLOPRODAUT,
                                             VRMAXDESCONTO = :VRMAXDESCONTO,
                                             IDUTLCORTEPED = :IDUTLCORTEPED,
                                             IDUTLSENHAOPER = :IDUTLSENHAOPER,
                                             IDALTTXSERV = :IDALTTXSERV,
                                             IDOBRFECHDLV = :IDOBRFECHDLV,
                                             IDSELECONSABERMESA = :IDSELECONSABERMESA,
                                             IDCONDPEDPAG = :IDCONDPEDPAG
                                        WHERE (NRORG    = :NRORG) 
                                        AND   (CDLOJA   = :CDLOJA) 
                                        AND   (CDFILIAL = :CDFILIAL)";
                                        
    const UPDATE_FRENTE_DE_CAIXA_4 = "UPDATE LOJA 
                                        SET
                                          IDUTILLOGGI = :IDUTILLOGGI,
                                          CDURLWSLOGGI = :CDURLWSLOGGI,
                                          DSEMAILLOGGI = :DSEMAILLOGGI,
                                          CDAPIKEYLOGGI = :CDAPIKEYLOGGI,
                                          IDSINCQUANTDIA = :IDSINCQUANTDIA,
                                          IDALTORIGPEDDLV = :IDALTORIGPEDDLV,
                                          DSENDEZEBRA = :DSENDEZEBRA,
                                          IDSOLOPERTXSRVAP = :IDSOLOPERTXSRVAP,
                                          IDORDCONTENTR = :IDORDCONTENTR,
                                          IDIMPPUXANTPED = :IDIMPPUXANTPED,
                                          IDCRMBONUS = :IDCRMBONUS,
                                          CDURLCRMBONUS = :CDURLCRMBONUS,
                                          CDAUTHCRMBONUS = :CDAUTHCRMBONUS,
                                          CDCODECRMBONUS = :CDCODECRMBONUS
                                        WHERE (NRORG = :NRORG) 
                                            AND (CDLOJA = :CDLOJA) 
                                            AND (CDFILIAL = :CDFILIAL)";
}